/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     INCLUDE = 258,
     EQUAL = 259,
     DIST_CONST = 260,
     DIST_EXP = 261,
     DIST_MARKOV = 262,
     DIST_MARKOV2 = 263,
     DIST_UNIFORM = 264,
     DIST_PARETO = 265,
     ARRIVAL = 266,
     AT = 267,
     AVERAGE = 268,
     BANDWIDTH = 269,
     DATA = 270,
     DELAY = 271,
     INTERACTIVE = 272,
     INTERVAL = 273,
     LENGTH = 274,
     LOG = 275,
     LOSS = 276,
     MTU = 277,
     ON = 278,
     PATIENCE = 279,
     PEAK = 280,
     RCVWIN = 281,
     RESPONSELENGTH = 282,
     SEED = 283,
     SERVER = 284,
     SETUP = 285,
     SNDWIN = 286,
     TIME = 287,
     TOS = 288,
     TTL = 289,
     WAIT = 290,
     ADDR = 291,
     FILENAME = 292,
     FLOATING_POINT = 293,
     HEX_INTEGER = 294,
     IDENTIFIER = 295,
     INTEGER = 296,
     OCTAL_INTEGER = 297,
     PROTOCOL = 298,
     SMALL_INTEGER = 299,
     STRING_LITERAL = 300,
     ADDRESS = 301,
     PACKET = 302,
     RESET = 303
   };
#endif
#define INCLUDE 258
#define EQUAL 259
#define DIST_CONST 260
#define DIST_EXP 261
#define DIST_MARKOV 262
#define DIST_MARKOV2 263
#define DIST_UNIFORM 264
#define DIST_PARETO 265
#define ARRIVAL 266
#define AT 267
#define AVERAGE 268
#define BANDWIDTH 269
#define DATA 270
#define DELAY 271
#define INTERACTIVE 272
#define INTERVAL 273
#define LENGTH 274
#define LOG 275
#define LOSS 276
#define MTU 277
#define ON 278
#define PATIENCE 279
#define PEAK 280
#define RCVWIN 281
#define RESPONSELENGTH 282
#define SEED 283
#define SERVER 284
#define SETUP 285
#define SNDWIN 286
#define TIME 287
#define TOS 288
#define TTL 289
#define WAIT 290
#define ADDR 291
#define FILENAME 292
#define FLOATING_POINT 293
#define HEX_INTEGER 294
#define IDENTIFIER 295
#define INTEGER 296
#define OCTAL_INTEGER 297
#define PROTOCOL 298
#define SMALL_INTEGER 299
#define STRING_LITERAL 300
#define ADDRESS 301
#define PACKET 302
#define RESET 303




/* Copy the first part of user declarations.  */
#line 1 "tg.y"

/************************************************************************
 *									*
 *	File:  tg.y							*
 *									*
 *	Traffic Generation command grammar.				*
 *									*
 *	Written 19-Jun-90 by Paul E. McKenney, SRI International.	*
 *	Copyright (c) 1989 by SRI International.			*
 *									*
 ************************************************************************/

#ifndef lint 
static char rcsid[] = "$Header: /nfs/ruby/pingali/tg/isitg/dist/tg2.0/src/tg/RCS/tg.y,v 1.2 2002/01/24 23:25:28 pingali Exp $";
#endif 

/* Include files.							*/

#include <stdio.h>
#ifdef FREEBSD
#include <stdlib.h>
#else
#include <search.h>
#include <malloc.h>
#endif
#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <math.h>
#include <time.h> 
#include "config.h"
#include "distribution.h"
#include "protocol.h"
#include "log.h"

/* Type definitions local to this file.					*/

#define MAXSYM		512

#define SYMcpy(a, b)	{ \
			(void)strncpy((a), (b), MAXSYM); \
			(a)[MAXSYM - 1] = '\0'; \
			}

#define SYMcat(a, b)	{ \
			(void)strncat((a), (b), MAXSYM - strlen(a) - 1); \
			}

typedef enum srvr_state_flag_		/* server packet parse state.	*/
	{
	srvr_len,			/* Accumulate reply length.	*/
	srvr_skip,			/* Accumulate skip distance.	*/
	srvr_skipping			/* Skip to next reply length.	*/
	} srvr_state_flag;

typedef struct srvr_state_		/* per-asn state variables.	*/
	{
	struct srvr_state_ *next;
	long		asn;		/* asn that this state is for.	*/
	int		bad;		/* asn has corrupted data.	*/
	srvr_state_flag	state;		/* Current state.		*/
	unsigned long	acc;		/* accumulate compressed number.*/
	int		nbytes;		/* # bytes accumulated so far.	*/
	int		special;	/* acc contains special number.	*/
	unsigned long	skip;		/* how many bytes to skip.	*/
	} srvr_state;

typedef struct				/* Yacc Symbol table entry TYPE.*/
	{
	int		flags;		/* FLAGS, same as symbol below.	*/
	int		lineno;		/* Line number for construct.	*/
	double		d;		/* token numeric value.		*/
	char		n[MAXSYM];	/* token name.			*/
	distribution	tmpdist;	/* Distribution when we aren't	*/
					/* sure which one we have.	*/
	struct sockaddr	tmpaddr;	/* Address when we aren't sure	*/
					/* which one we have.		*/
	tg_action	action;		/* Action descriptor.		*/
	protocol	prot;		/* Protocol descriptor.		*/
	}		strbuf;

#define YYSTYPE strbuf

/* Each entry of the expected-replies queue represents a packet that	*/
/* is expected to be received from a server.  If a given packet is	*/
/* not received by its timeout, we scream and die.  Packets are		*/
/* identified by the sequence number of the first byte following them,	*/
/* the sequence number of the first byte of the first packet is zero.	*/

typedef struct xpctd_replies_		/* expected-replies queue.	*/
	{
	struct xpctd_replies_ *next;
	unsigned long	byte_seqno;	/* seqno of 1st byte after	*/
					/* packet represented by this	*/
					/* struct.			*/
	struct timeval	timeout;	/* time at which patience gives	*/
					/* out.				*/
	} xpctd_replies;

/* Functions exported from this file.					*/

extern void		yyerror();

/* Functions local to this file.					*/

extern void		fix_times();
extern void		generate();
extern void		generate_interactive();
extern int		check_deadline();
extern int		start_log(struct timeval, char *format);
extern void		do_actions();
extern void		node_init();
extern int		rcv_pkt();
extern int		rcv_pkt_interactive();
extern int		rcv_pkt_interactive_srvr();
extern srvr_state	*srvr_state_get();
extern void		tg_append_element();
extern void		wait_start();
extern xpctd_replies	*xpctd_replies_get();
extern void		xpctd_replies_free();
extern void		yyerror();

/* Variables exported from this file.					*/

double			global_start;	/* global start time.		*/
struct timeval		global_start_tv; /* global start timeval.	*/
protocol		lexprot;	/* lex's protocol definition.	*/
protocol		prot;			/* Protocol definition.	*/
tg_action		*tg_first = NULL;	/* first TG action.	*/
tg_action		**tg_last = &tg_first;	/* last TG action.	*/
char                    *version = "2.0";	/* TG program version.	*/
char			*ofile = NULL;
char			*ifile = NULL;
 int			FlushOutput = 0;      /* whether to flush after each*/


/* Variables local to this file.					*/

static int		got_errors = 0;	/* Got errors during parse?	*/
static int		got_setup = 0;	/* Got a setup clause?		*/
static int		got_setup_implicit = 0;	/* an implicit one?	*/
static srvr_state	*srvr_state_h = NULL; /* per-asn srvr state list*/
static xpctd_replies	*xpctd_replies_flist = NULL;
					/* xr freelist.			*/
static xpctd_replies	*xpctd_replies_qh = NULL; /* xr queue header.	*/
static xpctd_replies	**xpctd_replies_qt = &xpctd_replies_qh;
					/* xr queue tail-pointer.	*/

char			logfilename[1024];
char			prefix[1024];
char			suffix[1024];

/* Symbol table */
struct sym_entry {
	char		*sym_name;
	int		sym_type;
	union {
	    int		intval;
	    char	*strval;
	    float	fltval;
	    double	dblval;
	} sym;

#define sym_intval	sym.intval
#define sym_strval	sym.strval
#define sym_fltval	sym.fltval
#define sym_dblval	sym.dblval

};

enum {
	SYM_INT_TYPE = 1,
	SYM_STR_TYPE,
	SYM_FLT_TYPE,
	SYM_DBL_TYPE,
};

#define SYM_TBL_SIZE	100

struct sym_entry sym_tbl[SYM_TBL_SIZE];

int	sym_tbl_index = 0;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 370 "tg.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  14
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   109

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  50
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  28
/* YYNRULES -- Number of rules. */
#define YYNRULES  71
/* YYNRULES -- Number of states. */
#define YYNSTATES  121

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   303

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    49,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     6,     8,    11,    15,    18,    21,    24,
      28,    32,    34,    35,    40,    45,    50,    55,    60,    65,
      69,    73,    76,    80,    84,    88,    92,    93,    96,    99,
     101,   104,   106,   108,   110,   114,   119,   125,   127,   129,
     132,   135,   138,   141,   144,   147,   148,   151,   154,   156,
     159,   162,   165,   167,   170,   173,   178,   184,   187,   191,
     196,   198,   202,   208,   210,   212,   214,   216,   218,   220,
     222,   224
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      51,     0,    -1,    52,    51,    -1,    53,    -1,     3,    45,
      -1,    54,    55,    59,    -1,    23,    73,    -1,    56,    58,
      -1,    57,    36,    -1,    57,    36,    29,    -1,    57,    36,
      36,    -1,    43,    -1,    -1,    58,    13,    14,    75,    -1,
      58,    25,    14,    75,    -1,    58,    13,    16,    75,    -1,
      58,    25,    16,    75,    -1,    58,    13,    21,    75,    -1,
      58,    25,    21,    75,    -1,    58,    26,    76,    -1,    58,
      31,    76,    -1,    58,    17,    -1,    58,    18,    75,    -1,
      58,    22,    76,    -1,    58,    34,    76,    -1,    58,    33,
      76,    -1,    -1,    59,    60,    -1,    61,    62,    -1,    62,
      -1,    12,    73,    -1,    63,    -1,    64,    -1,    65,    -1,
      66,    67,    70,    -1,    66,    67,    68,    70,    -1,    66,
      67,    68,    69,    70,    -1,    30,    -1,    35,    -1,    35,
      73,    -1,    20,    45,    -1,    11,    72,    -1,    19,    72,
      -1,    27,    72,    -1,    24,    73,    -1,    -1,    70,    71,
      -1,    15,    75,    -1,    48,    -1,    47,    75,    -1,    28,
      76,    -1,    32,    73,    -1,    75,    -1,     5,    75,    -1,
       6,    75,    -1,     6,    75,    75,    75,    -1,     8,    75,
      72,    75,    72,    -1,     9,    75,    -1,     9,    75,    75,
      -1,    10,    75,    75,    75,    -1,    74,    -1,    77,    49,
      74,    -1,    77,    49,    77,    49,    74,    -1,    38,    -1,
      77,    -1,    38,    -1,    76,    -1,    39,    -1,    41,    -1,
      42,    -1,    44,    -1,    41,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   222,   222,   223,   233,   290,   297,   322,   333,   339,
     345,   355,   366,   370,   376,   382,   388,   394,   400,   406,
     412,   418,   423,   429,   435,   441,   453,   455,   475,   481,
     488,   500,   504,   508,   512,   518,   526,   538,   557,   564,
     575,   592,   603,   612,   620,   629,   632,   640,   646,   651,
     657,   663,   672,   679,   686,   694,   711,   722,   730,   747,
     791,   795,   799,   806,   810,   817,   821,   828,   832,   836,
     843,   847
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INCLUDE", "EQUAL", "DIST_CONST",
  "DIST_EXP", "DIST_MARKOV", "DIST_MARKOV2", "DIST_UNIFORM", "DIST_PARETO",
  "ARRIVAL", "AT", "AVERAGE", "BANDWIDTH", "DATA", "DELAY", "INTERACTIVE",
  "INTERVAL", "LENGTH", "LOG", "LOSS", "MTU", "ON", "PATIENCE", "PEAK",
  "RCVWIN", "RESPONSELENGTH", "SEED", "SERVER", "SETUP", "SNDWIN", "TIME",
  "TOS", "TTL", "WAIT", "ADDR", "FILENAME", "FLOATING_POINT",
  "HEX_INTEGER", "IDENTIFIER", "INTEGER", "OCTAL_INTEGER", "PROTOCOL",
  "SMALL_INTEGER", "STRING_LITERAL", "ADDRESS", "PACKET", "RESET", "':'",
  "$accept", "statements", "include", "commands", "start_time",
  "association_spec", "protocol_and_addresses", "protocol",
  "quality_of_service", "tg_entry_list", "tg_entry", "at_clause",
  "tg_action", "tg_action_setup", "tg_action_wait", "tg_action_log",
  "tg_action_arrival", "tg_action_length", "tg_action_resplen",
  "tg_action_patience", "tg_action_modifier_list", "tg_action_modifier",
  "distribution", "time_literal", "decimal_number", "number", "integer",
  "decimal_integer", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    50,    51,    51,    52,    53,    54,    55,    56,    56,
      56,    57,    58,    58,    58,    58,    58,    58,    58,    58,
      58,    58,    58,    58,    58,    58,    59,    59,    60,    60,
      61,    62,    62,    62,    62,    62,    62,    63,    64,    64,
      65,    66,    67,    68,    69,    70,    70,    71,    71,    71,
      71,    71,    72,    72,    72,    72,    72,    72,    72,    72,
      73,    73,    73,    74,    74,    75,    75,    76,    76,    76,
      77,    77
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     1,     2,     3,     2,     2,     2,     3,
       3,     1,     0,     4,     4,     4,     4,     4,     4,     3,
       3,     2,     3,     3,     3,     3,     0,     2,     2,     1,
       2,     1,     1,     1,     3,     4,     5,     1,     1,     2,
       2,     2,     2,     2,     2,     0,     2,     2,     1,     2,
       2,     2,     1,     2,     2,     4,     5,     2,     3,     4,
       1,     3,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,     0,     3,     0,     4,    63,    71,
      70,     6,    60,    64,     1,     2,    11,    26,    12,     0,
       0,     5,     7,     8,    61,    64,     0,     0,     0,    37,
      38,    27,     0,    29,    31,    32,    33,     0,     0,    21,
       0,     0,     0,     0,     0,     0,     0,     9,    10,     0,
       0,     0,     0,     0,     0,    65,    67,    68,    69,    41,
      52,    66,    30,    40,    39,    28,     0,    45,     0,     0,
       0,    22,    23,     0,     0,     0,    19,    20,    25,    24,
      62,    64,    53,    54,     0,    57,     0,    42,     0,    45,
      34,    13,    15,    17,    14,    16,    18,     0,     0,    58,
       0,    43,     0,    45,    35,     0,     0,     0,     0,    48,
      46,    55,     0,    59,    44,    36,    47,    50,    51,    49,
      56
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     3,     4,     5,     6,    17,    18,    19,    22,    21,
      31,    32,    33,    34,    35,    36,    37,    67,    89,   103,
      90,   110,    59,    11,    12,    60,    61,    13
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -65
static const yysigned_char yypact[] =
{
       3,   -29,    65,    25,     3,   -65,   -26,   -65,   -65,   -65,
     -65,   -65,   -65,   -10,   -65,   -65,   -65,   -65,   -65,    21,
      65,    51,    71,    14,   -65,     4,    13,    65,    15,   -65,
      65,   -65,    57,   -65,   -65,   -65,   -65,    48,    58,   -65,
      -1,    59,    62,    59,    59,    59,    59,   -65,   -65,    65,
      -1,    -1,    -1,    -1,    -1,   -65,   -65,   -65,   -65,   -65,
     -65,   -65,   -65,   -65,   -65,   -65,    13,    46,    -1,    -1,
      -1,   -65,   -65,    -1,    -1,    -1,   -65,   -65,   -65,   -65,
     -65,   -65,   -65,    -1,    13,    -1,    -1,   -65,    13,    61,
      17,   -65,   -65,   -65,   -65,   -65,   -65,    -1,    -1,   -65,
      -1,   -65,    65,   -65,    17,    -1,    59,    65,    -1,   -65,
     -65,   -65,    13,   -65,   -65,    17,   -65,   -65,   -65,   -65,
     -65
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -65,    78,   -65,   -65,   -65,   -65,   -65,   -65,   -65,   -65,
     -65,   -65,    63,   -65,   -65,   -65,   -65,   -65,   -65,   -65,
     -61,   -65,   -64,   -27,   -16,   -39,   -36,     7
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      62,    71,    87,    64,    24,    72,     1,    76,    77,    78,
      79,    82,    83,    84,    85,    86,     7,    16,    50,    51,
      98,    52,    53,    54,   101,    14,     2,    25,   104,    91,
      92,    93,   105,    80,    94,    95,    96,    55,    56,    20,
      57,    58,   115,    47,    97,   106,    99,   100,   120,   107,
      48,    55,    56,    49,    57,    58,    81,    23,   111,   112,
      63,   113,    26,    27,   108,   109,   116,    66,    26,   119,
     117,    28,    68,    88,    69,   114,    73,    28,    74,    70,
     118,    29,    15,    75,    38,   102,    30,    29,    39,    40,
       0,     0,    30,    41,     0,    65,    42,    43,    56,     0,
      57,    58,    44,     8,    45,    46,     9,     0,     0,    10
};

static const yysigned_char yycheck[] =
{
      27,    40,    66,    30,    20,    41,     3,    43,    44,    45,
      46,    50,    51,    52,    53,    54,    45,    43,     5,     6,
      84,     8,     9,    10,    88,     0,    23,    20,    89,    68,
      69,    70,    15,    49,    73,    74,    75,    38,    39,    49,
      41,    42,   103,    29,    83,    28,    85,    86,   112,    32,
      36,    38,    39,    49,    41,    42,    49,    36,    97,    98,
      45,   100,    11,    12,    47,    48,   105,    19,    11,   108,
     106,    20,    14,    27,    16,   102,    14,    20,    16,    21,
     107,    30,     4,    21,    13,    24,    35,    30,    17,    18,
      -1,    -1,    35,    22,    -1,    32,    25,    26,    39,    -1,
      41,    42,    31,    38,    33,    34,    41,    -1,    -1,    44
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,    23,    51,    52,    53,    54,    45,    38,    41,
      44,    73,    74,    77,     0,    51,    43,    55,    56,    57,
      49,    59,    58,    36,    74,    77,    11,    12,    20,    30,
      35,    60,    61,    62,    63,    64,    65,    66,    13,    17,
      18,    22,    25,    26,    31,    33,    34,    29,    36,    49,
       5,     6,     8,     9,    10,    38,    39,    41,    42,    72,
      75,    76,    73,    45,    73,    62,    19,    67,    14,    16,
      21,    75,    76,    14,    16,    21,    76,    76,    76,    76,
      74,    77,    75,    75,    75,    75,    75,    72,    27,    68,
      70,    75,    75,    75,    75,    75,    75,    75,    72,    75,
      75,    72,    24,    69,    70,    15,    28,    32,    47,    48,
      71,    75,    75,    75,    73,    70,    75,    76,    73,    75,
      72
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 234 "tg.y"
    {
		FILE	*fd;

		fprintf(stderr, "including \"%s\"\n", yyvsp[0].n); 

		if (include_level > MAX_INCLUDE_LEVEL) {
			fprintf(stderr, "too many levels of inclusion\n");
			exit(-1);
		}
		if ((fd = fopen(yyvsp[0].n, "r")) == NULL) {
			fprintf(stderr, "can't open include file \"%s\"\n",
				yyvsp[0].n);
			exit(-1);
		}
		file_tbl[include_level].fd = yyin;
		file_tbl[include_level].cnt = yylineno;
		strcpy(file_tbl[include_level].name, current_config_file);
#if defined(FREEBSD) ||  defined(LINUX)
		file_tbl[include_level].stack = YY_CURRENT_BUFFER; 
#endif		
		yyin = fd;
		yylineno = 0;
		strcpy(current_config_file, yyvsp[0].n);
#if defined(FREEBSD) || defined(LINUX)
		yy_switch_to_buffer(yy_create_buffer(yyin, YY_BUF_SIZE)); 
#endif		

		include_level++;
		;}
    break;

  case 5:
#line 291 "tg.y"
    {
		prot = yyvsp[-1].prot;
		;}
    break;

  case 6:
#line 298 "tg.y"
    {
		struct timeval	tp;
		unsigned long	modulus = yyvsp[0].d;
		if (modulus == 0 ) 
		        {
			  yyerror("Start time must be greater than 0");
			  exit(1);			  
			}
		if (modulus != yyvsp[0].d)
			{
			yyerror("start_time: ON value must be integral");
			}
		if (gettimeofday(&tp, (struct timezone *)NULL) == -1)
			{
			perror("gettimeofday");
			exit(-1);
			}
		global_start = ((tp.tv_sec + modulus - 1) / modulus) * modulus;
		global_start_tv.tv_sec = global_start;
		global_start_tv.tv_usec = 0;
		;}
    break;

  case 7:
#line 323 "tg.y"
    {
		yyval = yyvsp[0];
		yyval.prot.qos |= yyvsp[-1].prot.qos;
		yyval.prot.src = yyvsp[-1].prot.src;
		yyval.prot.dst = yyvsp[-1].prot.dst;
		yyval.prot.prot = yyvsp[-1].prot.prot;
		;}
    break;

  case 8:
#line 334 "tg.y"
    {
		yyval = yyvsp[-1];
		yyval.prot.dst = yyvsp[0].tmpaddr;
		yyval.prot.qos = QOS_DST;
		;}
    break;

  case 9:
#line 340 "tg.y"
    {
		yyval = yyvsp[-2];
		yyval.prot.src = yyvsp[-1].tmpaddr;
		yyval.prot.qos = QOS_SRC | QOS_SERVER;
		;}
    break;

  case 10:
#line 346 "tg.y"
    {
		yyval = yyvsp[-2];
		yyval.prot.src = yyvsp[-1].tmpaddr;
		yyval.prot.dst = yyvsp[0].tmpaddr;
		yyval.prot.qos = QOS_SRC | QOS_DST;
		;}
    break;

  case 11:
#line 356 "tg.y"
    {
		node_init(&yyval);
		yyval.prot.prot = yyvsp[0].prot.prot;
		lexprot = yyval.prot;
		BEGIN LEX_ADDRESS;
		;}
    break;

  case 12:
#line 366 "tg.y"
    {
		node_init(&yyval);
		;}
    break;

  case 13:
#line 371 "tg.y"
    {
		yyval = yyvsp[-3];
		yyval.prot.avg_bandwidth = yyvsp[0].d;
		yyval.prot.qos |= QOS_AVG_BANDWIDTH;
		;}
    break;

  case 14:
#line 377 "tg.y"
    {
		yyval = yyvsp[-3];
		yyval.prot.peak_bandwidth = yyvsp[0].d;
		yyval.prot.qos |= QOS_PEAK_BANDWIDTH;
		;}
    break;

  case 15:
#line 383 "tg.y"
    {
		yyval = yyvsp[-3];
		yyval.prot.avg_delay = yyvsp[0].d;
		yyval.prot.qos |= QOS_AVG_DELAY;
		;}
    break;

  case 16:
#line 389 "tg.y"
    {
		yyval = yyvsp[-3];
		yyval.prot.peak_delay = yyvsp[0].d;
		yyval.prot.qos |= QOS_PEAK_DELAY;
		;}
    break;

  case 17:
#line 395 "tg.y"
    {
		yyval = yyvsp[-3];
		yyval.prot.avg_loss = yyvsp[0].d;
		yyval.prot.qos |= QOS_AVG_LOSS;
		;}
    break;

  case 18:
#line 401 "tg.y"
    {
		yyval = yyvsp[-3];
		yyval.prot.peak_loss = yyvsp[0].d;
		yyval.prot.qos |= QOS_PEAK_LOSS;
		;}
    break;

  case 19:
#line 407 "tg.y"
    {
                    yyval = yyvsp[-2];
		    yyval.prot.rcvwin = yyvsp[0].d;
		    yyval.prot.qos |= QOS_RCVWIN;
		;}
    break;

  case 20:
#line 413 "tg.y"
    {
                    yyval = yyvsp[-2];
		    yyval.prot.sndwin = yyvsp[0].d;
		    yyval.prot.qos |= QOS_SNDWIN;
		;}
    break;

  case 21:
#line 419 "tg.y"
    {
		yyval = yyvsp[-1];
		yyval.prot.qos |= QOS_INTERACTIVE;
		;}
    break;

  case 22:
#line 424 "tg.y"
    {
		yyval = yyvsp[-2];
		yyval.prot.interval = yyvsp[0].d;
		yyval.prot.qos |= QOS_INTERVAL;
		;}
    break;

  case 23:
#line 430 "tg.y"
    {
		yyval = yyvsp[-2];
		yyval.prot.mtu = yyvsp[0].d;
		yyval.prot.qos |= QOS_MTU;
		;}
    break;

  case 24:
#line 436 "tg.y"
    {
		yyval = yyvsp[-2];
		yyval.prot.multicast_ttl = yyvsp[0].d;
		yyval.prot.qos |= QOS_TTL;
		;}
    break;

  case 25:
#line 442 "tg.y"
    {
		#ifdef SUNOS4
		  fprintf(stderr,"SunOS does not support setting TOS field.\n");
		  exit(1); 
                #endif	
		yyval = yyvsp[-2];
		yyval.prot.tos = yyvsp[0].d;
		yyval.prot.qos |= QOS_TOS;
		;}
    break;

  case 27:
#line 456 "tg.y"
    {

		/* Add the new entry to the linked list.  Note that	*/
		/* the chain represented by tg_entry_list has already	*/
		/* been added to the list, and need not be referred to,	*/
		/* thus there is no need for node_init in the above	*/
		/* empty clause.					*/

		*tg_last = (tg_action *)malloc(sizeof(tg_action));
		if (*tg_last == NULL)
			{
			yyerror("tg_entry_list: Out of memory");
			}
		**tg_last = yyvsp[0].action;
		tg_last = &((*tg_last)->next);
		;}
    break;

  case 28:
#line 476 "tg.y"
    {
		yyval = yyvsp[0];
		yyval.action.tg_flags |= yyvsp[-1].action.tg_flags;
		yyval.action.start_at = yyvsp[-1].action.start_at;
		;}
    break;

  case 29:
#line 482 "tg.y"
    {
		yyval = yyvsp[0];
		;}
    break;

  case 30:
#line 489 "tg.y"
    {
		double		tmp;

		node_init(&yyval);
		tmp = global_start + yyvsp[0].d;
		dtotimeval(tmp, &yyval.action.start_at);
		yyval.action.tg_flags |= TG_START;
		;}
    break;

  case 31:
#line 501 "tg.y"
    {
		yyval = yyvsp[0];
		;}
    break;

  case 32:
#line 505 "tg.y"
    {
		yyval = yyvsp[0];
		;}
    break;

  case 33:
#line 509 "tg.y"
    {
		yyval = yyvsp[0];
		;}
    break;

  case 34:
#line 513 "tg.y"
    {
		yyval = yyvsp[-2];
		tg_append_element(&yyval.action, &yyvsp[-1].action);
		tg_append_element(&yyval.action, &yyvsp[0].action);
		;}
    break;

  case 35:
#line 520 "tg.y"
    {
		yyval = yyvsp[-3];
		tg_append_element(&yyval.action, &yyvsp[-2].action);
		tg_append_element(&yyval.action, &yyvsp[-1].action);
		tg_append_element(&yyval.action, &yyvsp[0].action);
		;}
    break;

  case 36:
#line 528 "tg.y"
    {
		yyval = yyvsp[-4];
		tg_append_element(&yyval.action, &yyvsp[-3].action);
		tg_append_element(&yyval.action, &yyvsp[-2].action);
		tg_append_element(&yyval.action, &yyvsp[-1].action);
		tg_append_element(&yyval.action, &yyvsp[0].action);
		;}
    break;

  case 37:
#line 539 "tg.y"
    {
		node_init(&yyval);
		if (got_setup)
			{
			yyerror("Multiple setup clauses not supported");
			YYERROR;
			}
		if (got_setup_implicit)
			{
			yyerror("setup clause not legal after implicit setup");
			YYERROR;
			}
		got_setup = 1;
		yyval.action.tg_flags |= TG_SETUP;
		;}
    break;

  case 38:
#line 558 "tg.y"
    {
		node_init(&yyval);
		if (!got_setup)
			got_setup_implicit = 1;
		yyval.action.tg_flags |= TG_WAIT;
		;}
    break;

  case 39:
#line 565 "tg.y"
    {
		node_init(&yyval);
		if (!got_setup)
			got_setup_implicit = 1;
		yyval.action.tg_flags |= TG_WAIT | TG_TIME;
		dtotimeval(yyvsp[0].d, &yyval.action.time_limit);
		;}
    break;

  case 40:
#line 576 "tg.y"
    {
		char		*cp;

		node_init(&yyval);
		if (!got_setup)
			got_setup_implicit = 1;
		yyval.action.tg_flags |= TG_LOG;
		if (!(cp = malloc (strlen(yyvsp[0].n) + 1))) {
			perror("malloc");
			exit (-1);
		}
		strcpy (cp, yyvsp[0].n);
		yyval.action.log = cp;
		;}
    break;

  case 41:
#line 593 "tg.y"
    {
		node_init(&yyval);
		if (!got_setup)
			got_setup_implicit = 1;
		yyval.action.tg_flags |= TG_ARRIVAL;
		yyval.action.arrival = yyvsp[0].tmpdist;
		;}
    break;

  case 42:
#line 604 "tg.y"
    {
		node_init(&yyval);
		yyval.action.tg_flags |= TG_LENGTH;
		yyval.action.length = yyvsp[0].tmpdist;
		;}
    break;

  case 43:
#line 613 "tg.y"
    {
		node_init(&yyval);
		yyval.action.tg_flags |= TG_RESPLEN;
		yyval.action.resplen = yyvsp[0].tmpdist;
		;}
    break;

  case 44:
#line 621 "tg.y"
    {
		node_init(&yyval);
		yyval.action.tg_flags |= TG_PATIENCE;
		dtotimeval(yyvsp[0].d, &yyval.action.patience);
		;}
    break;

  case 45:
#line 629 "tg.y"
    {
		node_init(&yyval);
		;}
    break;

  case 46:
#line 633 "tg.y"
    {
		yyval = yyvsp[-1];
		tg_append_element(&yyval.action, &yyvsp[0].action);
		;}
    break;

  case 47:
#line 641 "tg.y"
    {
		node_init(&yyval);
		yyval.action.tg_flags |= TG_DATA;
		yyval.action.data_limit = yyvsp[0].d;
		;}
    break;

  case 48:
#line 647 "tg.y"
    {
		node_init(&yyval);
		yyval.action.tg_flags |= TG_RESET;
		;}
    break;

  case 49:
#line 652 "tg.y"
    {
		node_init(&yyval);
		yyval.action.tg_flags |= TG_PACKET;
		yyval.action.packet_limit = yyvsp[0].d;
		;}
    break;

  case 50:
#line 658 "tg.y"
    {
		node_init(&yyval);
		yyval.action.tg_flags |= TG_SEED;
		yyval.action.seed = yyvsp[0].d;
		;}
    break;

  case 51:
#line 664 "tg.y"
    {
		node_init(&yyval);
		yyval.action.tg_flags |= TG_TIME;
		dtotimeval(yyvsp[0].d, &yyval.action.time_limit);
		;}
    break;

  case 52:
#line 673 "tg.y"
    {
		char		*cp;

		if ((cp = dist_const_init(&yyval.tmpdist, yyvsp[0].d)) != NULL)
			yyerror(cp);
		;}
    break;

  case 53:
#line 680 "tg.y"
    {
		char		*cp;

		if ((cp = dist_const_init(&yyval.tmpdist, yyvsp[0].d)) != NULL)
			yyerror(cp);
		;}
    break;

  case 54:
#line 687 "tg.y"
    {
		char		*cp;

		if ((cp = dist_exp_init(&yyval.tmpdist, yyvsp[0].d, (double) 0,
					(double) MAX_RANDOM)) != NULL)
			yyerror(cp);
		;}
    break;

  case 55:
#line 695 "tg.y"
    {
		char		*cp;
		
		if (yyvsp[-1].d < yyvsp[0].d)
			{
			if ((cp = dist_exp_init(&yyval.tmpdist, yyvsp[-2].d, yyvsp[-1].d,
						yyvsp[0].d)) != NULL)
				yyerror(cp);
			}
		else 
			{
			if ((cp = dist_exp_init(&yyval.tmpdist, yyvsp[-2].d, yyvsp[0].d,
						yyvsp[-1].d)) != NULL)
				yyerror(cp);
			}
		;}
    break;

  case 56:
#line 712 "tg.y"
    {
		char		*cp;

		if ((cp = dist_markov2_init(&yyval.tmpdist,
					    yyvsp[-3].d,
					    &(yyvsp[-2].tmpdist),
					    yyvsp[-1].d,
					    &(yyvsp[0].tmpdist))) != NULL)
			yyerror(cp);
		;}
    break;

  case 57:
#line 723 "tg.y"
    {
		char		*cp;

		if ((cp = dist_uniform_init(&yyval.tmpdist,
					    (double) 0, yyvsp[0].d)) != NULL)
			yyerror(cp);
		;}
    break;

  case 58:
#line 731 "tg.y"
    {
		char		*cp;

		if (yyvsp[-1].d < yyvsp[0].d)
			{
			if ((cp = dist_uniform_init(&yyval.tmpdist,
						    yyvsp[-1].d, yyvsp[0].d)) != NULL)
				yyerror(cp);
			}
		else
			{
			if ((cp = dist_uniform_init(&yyval.tmpdist,
						    yyvsp[0].d, yyvsp[-1].d)) != NULL)
				yyerror(cp);
			}
		;}
    break;

  case 59:
#line 748 "tg.y"
    {
		char		*cp;

		if ((cp = dist_pareto_init(&yyval.tmpdist,
						    yyvsp[-2].d, yyvsp[-1].d, yyvsp[0].d)) != NULL)
				yyerror(cp);
		;}
    break;

  case 60:
#line 792 "tg.y"
    {
		yyval.d = yyvsp[0].d;
		;}
    break;

  case 61:
#line 796 "tg.y"
    {
		yyval.d = yyvsp[-2].d * 60 + yyvsp[0].d;
		;}
    break;

  case 62:
#line 800 "tg.y"
    {
		yyval.d = (yyvsp[-4].d * 60 + yyvsp[-2].d) * 60 + yyvsp[0].d;
		;}
    break;

  case 63:
#line 807 "tg.y"
    {
		yyval.d = yyvsp[0].d;
		;}
    break;

  case 64:
#line 811 "tg.y"
    {
		yyval.d = yyvsp[0].d;
		;}
    break;

  case 65:
#line 818 "tg.y"
    {
		yyval.d = yyvsp[0].d;
		;}
    break;

  case 66:
#line 822 "tg.y"
    {
		yyval.d = yyvsp[0].d;
		;}
    break;

  case 67:
#line 829 "tg.y"
    {
		yyval.d = yyvsp[0].d;
		;}
    break;

  case 68:
#line 833 "tg.y"
    {
		yyval.d = yyvsp[0].d;
		;}
    break;

  case 69:
#line 837 "tg.y"
    {
		yyval.d = yyvsp[0].d;
		;}
    break;

  case 70:
#line 844 "tg.y"
    {
		yyval.d = yyvsp[0].d;
		;}
    break;

  case 71:
#line 848 "tg.y"
    {
		yyval.d = yyvsp[0].d;
		;}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 2057 "tg.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 853 "tg.y"

#include "lex.yy.c"

/* MAINprogram for extractdoc.						*/

main(argc, argv)

	int		argc;
	char		*argv[];

	{
	extern int	yydebug;
	void		sigint();
	FILE		*fp;

	/* Set debugging if it is desired.				*/

#	if YYDEBUG
	/*yydebug = 1; */
#	endif

	/* Initialize lex state.					*/

	lex_init(argc, argv);
	
	/* fix the outputfile format */ 
	if (ofile != NULL) {
	  int i,j; 

	  prefix[0] = '\0'; 
	  suffix[0] = '\0'; 
	  for (i = strlen(ofile) - 1 ; i >= 0 ; i-- ) 
	    if ( ofile[i] == '.')
	      break; 
	  for (j =0 ; j < i ; j++ ) 
	    prefix[j] = ofile[j]; 
	  for (j = i+1 ; j < strlen(ofile) ; j++ ) 
	    suffix[j - i -1] = ofile[j]; 

	  if (0) fprintf(stderr, "ofile = %s, prefix = %s, suffix = %s \n", 
		  ofile, prefix, suffix ); 
	  
	}

	BEGIN LEX_NORMAL;

	/* Convert input.						*/

	if (yyparse() != 0)
		exit(1);
	if (got_errors)
		exit(1);

	(void) signal(SIGINT, sigint);
	(void) signal(SIGTERM, sigint);

	/*
	 * Set up logging.  If ofile is set, then we write to the 
	 * specified file.
	 */

	/* Start logging						*/

	start_log(global_start_tv, NULL);

	/* Fix up start and stop times.					*/

	fix_times();

	/* Wait for global start time, scream if it has already passed.	*/

	wait_start();

	/* Generate traffic.						*/

	do_actions();
	return (0);
	}

start_log(on_timeval, format)
	struct timeval on_timeval;	/* Starting timeval structure */
	char *format; 
	{
	FILE		*fp;
	time_t          now; 
	char buf[1024]; 
	int i; 
	
	if (ofile != NULL) { 
	  if (format != NULL ) { 
	    
	    now = on_timeval.tv_sec;
#ifdef SUNOS4
	    /* good old sunos 4.x */ 
	    if (1) {	      
	      struct tm *timebuf;
	      timebuf = gmtime(&now);
	      strftime(&buf[0], 1024,format, timebuf);
	    }
#else 
	    if (1) { 
	      struct tm timebuf;
	      (void) gmtime_r(&now, &timebuf);
	      strftime(&buf[0], 1024,format, &timebuf);
	    }
#endif
	    /* replace the forward slashes...*/ 
	    for (i= 0 ; i < strlen(buf); i++) 
	      if ( buf[i] == '/') 
		buf[i] = '_'; 
	    sprintf(logfilename, "%s.%s.%s", prefix, buf, suffix); 	
	    
	  } else {
	    
	    sprintf(logfilename, "%s.%s", prefix, suffix); 	
	    
	  }
	  
	  if (0) fprintf(stderr, "Log:  before editing %s\n", logfilename);

	  /*
	   * Set up logging.  If ofile is set, then we write to the 
	   * specified file.
	   */
	  if ((fp = log_open(logfilename)) == (FILE *) NULL) {
	    exit (-1);
	  }

	} else {

	  /* output file undefined */
	  if ((fp = log_open(NULL)) == (FILE *) NULL) {
	    exit (-1);
	  }	  

	}

	log_init(fp, on_timeval, prot.prot->name, prot.prot->af,
		ifile, &prot);
	}


/* Perform tasks based on list of actions.				*/

void
do_actions()

	{
	tg_action	*cur_tg;
	struct timeval	lasttime;
	long		tx_asn = -1;

	/* Set up receive routine.					*/

	if ((prot.qos & QOS_INTERACTIVE) == 0)
		prot.prot->rcv = rcv_pkt;
	else if ((prot.qos & QOS_SERVER) == 0)
		prot.prot->rcv = rcv_pkt_interactive;
	else
		prot.prot->rcv = rcv_pkt_interactive_srvr;

	/* If there is no explicit setup clause, do an immediate setup.	*/
															/*******************/
	if (got_setup_implicit && ((tx_asn = (*(prot.prot->setup))(&prot)) == -1))
		{
		/* log the setup error. */

		perror("do_actions: protocol setup");
		exit(-1);
		}

	/* Each pass through the following loop processes one tg_action	*/
	/* element from the list.					*/

	for (cur_tg = tg_first; cur_tg != NULL; cur_tg = cur_tg->next)
		{

		/* Wait for start time, if one was specified.  Remember	*/
		/* the start time (or the current time, if the start	*/
		/* time is not specified) in ``lasttime''.		*/

		if ((cur_tg->tg_flags & TG_START) != 0)
			{
			(*(prot.prot->sleep_till))(&(cur_tg->start_at));
			lasttime = cur_tg->start_at;
			}
		else
			{
			if (gettimeofday(&lasttime,
					 (struct timezone *)NULL) == -1)
				{
				perror("do_actions: gettimeofday");
				abort();
				}
			}

		/* Compute stop time on the fly, if needed.		*/

		if ((cur_tg->tg_flags & TG_STOP) == 0)
			{
			if ((cur_tg->tg_flags & TG_TIME) == 0)
				{

				/* No definite stop time, set it for	*/
				/* some time in the year 2038...	*/

				cur_tg->stop_before.tv_sec = 0x7fffffff;
				}
			else
				{

				/* Add the time limit to the current	*/
				/* time to get the stop time.		*/

				timeradd(&lasttime,
					 &cur_tg->time_limit,
					 &cur_tg->stop_before);
				}
			}

		/* Perform the specified action.			*/

		if ((cur_tg->tg_flags & TG_SETUP) != 0)
			{

			/* Perform setup phase.				*/

			if ((tx_asn = (*(prot.prot->setup))(&prot)) == -1)
				{

				/* log the setup error. */

				perror("do_actions: protocol setup");
				exit(-1);
				}
			}
		else if ((cur_tg->tg_flags & TG_WAIT) != 0)
			{

			/* If we would run out of patience before the	*/
			/* end of the wait, wait for the patience	*/
			/* interval.					*/

			while ((xpctd_replies_qh != NULL) &&
			       (timercmp(&(xpctd_replies_qh->timeout),
					 &(cur_tg->stop_before),
					 <)))
				{

				/* Check to see if timeout has already	*/
				/* passed..				*/

				if (check_deadline
						(&(xpctd_replies_qh->timeout)))
					{

					/* @@@@ log frustration!	*/

					(void)fprintf(stderr,
						      "Patience exceeded!\n");
					exit(-1);
					}
				
				/* Wait for the timeout if not.		*/

				(*(prot.prot->sleep_till))
					(&(xpctd_replies_qh->timeout));
				}

			/* Just wait until the interval is over.	*/

			(*(prot.prot->sleep_till))(&(cur_tg->stop_before));
			}
		else if ((cur_tg->tg_flags & TG_LOG) != 0)
			{
			/* (Re-)Start logging to a new file */
			time_t now;
			struct timeval on_timeval;
			
			log_close();
			(void) time(&now);
			on_timeval.tv_sec = now;
			on_timeval.tv_usec = 0;
			start_log(on_timeval, cur_tg->log);
			}
		else if ((prot.qos & QOS_INTERACTIVE) != 0)
			{

			/* Generate traffic as specified by arrival	*/
			/* and length.					*/

			generate_interactive(tx_asn, cur_tg, lasttime);
			}
		else
			{

			/* Generate traffic as specified by arrival	*/
			/* and length.					*/

			generate(tx_asn, cur_tg, lasttime);
			}
		}

	/* Finished, tear down connection.				*/

	if ((*(prot.prot->teardown))(tx_asn) == -1)
		{

		/* log the teardown error. */

		perror("do_actions: protocol teardown");
		exit(-1);
		}

	return;
	}

/* Fix up start and stop times and perform semantic checks.		*/

void
fix_times()

	{
	tg_action	*cur_tg;

	/* Scan action list, computing all times that can be computed	*/
	/* beforehand.							*/

	for (cur_tg = tg_first; cur_tg != NULL; cur_tg = cur_tg->next)
		{

		/* If we aren't interactive and someone is trying to	*/
		/* do a responselength, scream.				*/

		if (((prot.qos & QOS_INTERACTIVE) == 0) &&
		    ((cur_tg->tg_flags & TG_RESPLEN) != 0))
			{
			(void)fprintf(stderr,
				      "resplen legal only if %s specified",
				      "interactive");
			exit(-1);
			}

		/* If there is no stop time, try to infer one.		*/

		if ((cur_tg->tg_flags & TG_STOP) == 0)
			{

			if ((cur_tg->tg_flags & (TG_START | TG_TIME)) ==
			    (TG_START | TG_TIME))
				{

				/* Infer from start time and limit.	*/

				cur_tg->tg_flags |= TG_STOP;
				timeradd(&(cur_tg->start_at),
					 &(cur_tg->time_limit),
					 &(cur_tg->stop_before));
				}
			else if ((cur_tg->next != NULL) &&
				 ((cur_tg->next->tg_flags & TG_START) != 0))
				{

				/* Infer from next actions start time.	*/

				if (!timercmp(&(cur_tg->next->start_at),
					      &(cur_tg->start_at),
					      >))
					{
					(void)fprintf(stderr,
						      "fix_times: %s\n",
						      "time clash");
					}
				cur_tg->tg_flags |= TG_STOP;
				cur_tg->stop_before = cur_tg->next->start_at;
				}
			}

		/* If there is now a stop time, make sure that it	*/
		/* does not conflict with the next item's start time.	*/
		/* If the next item does not have a start time, then	*/
		/* copy in the stop time from this item.		*/

		if (((cur_tg->tg_flags & TG_STOP) != 0) &&
		    (cur_tg->next != NULL))
			{
			if ((cur_tg->next->tg_flags & TG_START) == 0)
				{
				cur_tg->next->tg_flags |= TG_START;
				}
			else
				{
				if (timercmp(&(cur_tg->stop_before),
					     &(cur_tg->next->start_at),
					     >))
					{
					(void)fprintf(stderr,
						      "fix_times: %s\n",
						      "time clash");
					}
				}
			}
		}
	}

/* Check to see if current time has exceeded deadline.			*/

int
check_deadline(deadline)

	struct timeval	*deadline;

	{
	struct timeval	tv;

	if (gettimeofday(&tv, (struct timezone *)NULL) == -1)
		{
		perror("check_deadline: gettimeofday");
		abort();
		}
	return (timercmp(deadline, &tv, <));
	}

/* Generate traffic as specified by cur_tg.				*/

void
generate(tx_asn, cur_tg, lasttime)

	long		tx_asn;
	tg_action	*cur_tg;
	struct timeval	lasttime;
	{
	unsigned long	datasent = 0, pktsent = 0;
	static unsigned long	pktid = 0;

	/* Set random-number generator seed, if so  specified.		*/

	if ((cur_tg->tg_flags & TG_SEED) != 0) {
		/*(void)srand48(cur_tg->seed);*/srand(time(NULL));
	}

	/* Reset packet counter */

	if ((cur_tg->tg_flags & TG_RESET) != 0) {
		pktid = 0;
	}

	/* Generate traffic until either packet, data, or time limit	*/
	/* is exceeded.							*/

	for (;;)
		{
		char		*buf;
		struct timeval	nextpkt_tv;
		unsigned long	pktlen;
		double		arrival;

		/* Find arrival time for next packet.			*/

		arrival = (*(cur_tg->arrival.generate))(&cur_tg->arrival);
		if (arrival != 0.)
			{

			/* The interarrival time is not exactly zero,	*/
			/* count the time to start when the last packet	*/
			/* was scheduled to leave, rather than when it	*/
			/* actually left.				*/

			dtotimevalfromthen(&lasttime, arrival, &nextpkt_tv);
			}
		else
			{

			/* The interarrival time is zero, so get the	*/
			/* current time of day to check for stop times.	*/

			if (gettimeofday(&nextpkt_tv,
					 (struct timezone *)NULL) == -1)
				{
				perror("generate: gettimeofday");
				abort();
				}
			}

		/* If we are to stop this action before the next packet	*/
		/* is to arrive, just wait for the stop time.		*/

		if (!timercmp(&(cur_tg->stop_before), &nextpkt_tv, >))
			{
			(*(prot.prot->sleep_till))(&(cur_tg->stop_before));
			break;
			}

		/* Otherwise, wait until nextpkt_tv to transmit the	*/
		/* packet.						*/

		if (arrival != 0)
			(*(prot.prot->sleep_till))(&nextpkt_tv);
		lasttime = nextpkt_tv;

		/* Did we exceed the limit on the number of packets to send? */

		if (((cur_tg->tg_flags & TG_PACKET) != 0) &&
		    (++pktsent > cur_tg->packet_limit)) {

			break;
		}

		/* Get the packet length and see if the data limit has	*/
		/* been exceeded.					*/

		pktlen = (*(cur_tg->length.generate))(&cur_tg->length);
		if (((cur_tg->tg_flags & TG_DATA) != 0) &&
		    ((datasent += pktlen) > cur_tg->data_limit)) {

			/* The current packet would put us over the	*/
			/* limit, quit!					*/

			break;
		}

		/* Get a buffer for the packet and transmit it.		*/

		if ((buf = (*(prot.prot->buffer_get))(pktlen)) == NULL)
			{

			log_error(NULL, NULL, tx_asn, LOGERR_MEM);
			(void)fprintf(stderr,
				      "main: buffer %s\n",
				      "allocation failure");
			}
		else
			{

			(void)(*(prot.prot->send))(tx_asn,
						   buf,
						   pktlen,
						   &(cur_tg->stop_before),
						   &pktid);
			}
		}
	}

/* Generate interactive-like traffic as specified by cur_tg.		*/

void
generate_interactive(tx_asn, cur_tg, lasttime)

	long		tx_asn;
	tg_action	*cur_tg;
	struct timeval	lasttime;

	{
	unsigned long	datasent = 0, pktsent = 0;
	int		encodelen;
	static unsigned long minbuflen = 0;
	unsigned long	pktid;
	static unsigned long replydatawaiting = 0;
	unsigned long	resplen;

	/* Get minimum buffer length if we don't yet know it.		*/

	if (minbuflen == 0)
		minbuflen = encode_special_response((char *)NULL, 0, 0);

	/* Set random-number generator seed, if so specified.		*/

	if ((cur_tg->tg_flags & TG_SEED) != 0)
		{
		/*(void)srand48(cur_tg->seed);*/srand(time(NULL));
		}

	/* Generate traffic until either data limit or time limit	*/
	/* exceeded.							*/

	for (;;)
		{
		char		*buf;
		struct timeval	nextpkt_tv;
		unsigned long	pktlen;
		double		arrival;

		/* Find arrival time for next packet.			*/

		arrival = (*(cur_tg->arrival.generate))(&cur_tg->arrival);
		if (arrival != 0.)
			{

			/* The interarrival time is not exactly zero,	*/
			/* count the time to start when the last packet	*/
			/* was scheduled to leave, rather than when it	*/
			/* actually left.				*/

			dtotimevalfromthen(&lasttime, arrival, &nextpkt_tv);
			}
		else
			{

			/* The interarrival time is zero, so get the	*/
			/* current time of day to check for stop times.	*/

			if (gettimeofday(&nextpkt_tv,
					 (struct timezone *)NULL) == -1)
				{
				perror("generate: gettimeofday");
				abort();
				}
			}

		/* If we would run out of patience before the stop	*/
		/* time and before the next packet transmission time,	*/
		/* wait for the patience interval.			*/

		while ((xpctd_replies_qh != NULL) &&
		       (timercmp(&(xpctd_replies_qh->timeout),
				 &(cur_tg->stop_before),
				 <)) &&
		       (timercmp(&(xpctd_replies_qh->timeout), &nextpkt_tv, <)))
			{

			/* Check to see if timeout has already passed..	*/

			if (check_deadline(&(xpctd_replies_qh->timeout)))
				{

				/* @@@@ log frustration!		*/

				(void)fprintf(stderr, "Patience exceeded!\n");
				exit(-1);
				}
			
			/* Wait for the timeout if not.			*/

			(*(prot.prot->sleep_till))
				(&(xpctd_replies_qh->timeout));
			}

		/* If we are to stop this action before the next packet	*/
		/* is to arrive, just wait for the stop time.		*/

		if (!timercmp(&(cur_tg->stop_before), &nextpkt_tv, >))
			{
			(*(prot.prot->sleep_till))(&(cur_tg->stop_before));
			break;
			}

		/* Otherwise, wait until nextpkt_tv to transmit the	*/
		/* packet.						*/

		if (arrival != 0)
			(*(prot.prot->sleep_till))(&nextpkt_tv);
		lasttime = nextpkt_tv;

		/* Did we exceed the limit on the number of packets to send? */

		if (((cur_tg->tg_flags & TG_PACKET) != 0) &&
		    (++pktsent > cur_tg->packet_limit)) {

			break;
		}

		/* Get the packet length and see if the data limit has	*/
		/* been exceeded.					*/

		pktlen = (*(cur_tg->length.generate))(&cur_tg->length);
		if (((cur_tg->tg_flags & TG_DATA) != 0) &&
		    ((datasent += pktlen) > cur_tg->data_limit)) {

			/* The current packet would put us over the	*/
			/* limit, quit!					*/

			break;
		}

		/* Get a buffer for the packet and transmit it.		*/

		if ((buf = (*(prot.prot->buffer_get))(pktlen > minbuflen ?
						      pktlen : 
						      minbuflen)) == NULL)
			{

			log_error(NULL, NULL, tx_asn, LOGERR_MEM);
			(void)fprintf(stderr,
				      "main: buffer %s\n",
				      "allocation failure");
			}
		else
			{

			if ((cur_tg->tg_flags & TG_RESPLEN) == 0)
				{

				/* Encode a special zero to say that	*/
				/* we want no response.			*/

				encodelen = encode_special_response(buf,
								    pktlen,
								    0);
				}
			else
				{

				/* Generate desired response length.	*/

				resplen = (*(cur_tg->resplen.generate))
						(&(cur_tg->resplen));

				/* Encode the response length into the	*/
				/* packet and try to send it.		*/

				encodelen = encode_response(buf,
							    pktlen,
							    resplen);
				}

			/* Send the packet.				*/

			for (;;)
				{
				struct timeval	*tvp;

				/* Get a pointer to a timeout, either	*/
				/* the patience timeout or the end of	*/
				/* this action, whichever comes first.	*/

				if (xpctd_replies_qh == NULL)
					tvp = &(cur_tg->stop_before);
				else if (timercmp(&(cur_tg->stop_before),
						  &(xpctd_replies_qh->timeout),
						  >))
					tvp = &(xpctd_replies_qh->timeout);
				else
					tvp = &(cur_tg->stop_before);
				if ((*(prot.prot->send))(tx_asn,
							 buf,
							 pktlen > encodelen ?
								pktlen :
								encodelen,
							 tvp,
							 &pktid) == -1)
					{

					/* If we had a hard error or if	*/
					/* we hit the end of the action,*/
					/* quit.			*/

					if ((errno != ETIME) ||
					    (tvp == &(cur_tg->stop_before)))
						break;

					/* Check to see if patience	*/
					/* timeout has already passed..	*/

					if ((xpctd_replies_qh != NULL) &&
					    (check_deadline
						(&(xpctd_replies_qh->timeout))))
						{

						/* @@@@ log frustration!*/

						(void)fprintf(stderr,
							      "%s exceeded!\n",
							      "Patience");
						exit(-1);
						}
					}
				else
					{

					/* If this action is impatient,	*/
					/* make an xpctd-replies entry.	*/

					if ((cur_tg->tg_flags &
					     TG_PATIENCE) != 0)
						{
						xpctd_replies *p =
							xpctd_replies_get();

						p->byte_seqno =
							replydatawaiting;
						timeradd(&nextpkt_tv,
							 &(cur_tg->patience),
							 &(p->timeout));
						*xpctd_replies_qt = p;
						xpctd_replies_qt = &(p->next);

						/* Accumulate the total	*/
						/* amount of outstanding*/
						/* reply data expected.	*/

						replydatawaiting += resplen;
						}

					break;
					}
				}
			}
		}
	}

/* NODE INITialize.  Forces all fields to zero/NULL.			*/

void
node_init(node)

	YYSTYPE		*node;

	{

	(void)memset((char *)node, 0, sizeof(*node));
	}

/* Receive and log packet.						*/

int
rcv_pkt(rx_asn, tx_asn, buf, len, pktid)

	long		rx_asn;
	long		tx_asn;
	char		*buf;
	int		len;
	unsigned long	pktid;

	{

	/* Do nothing, since the protocol logs it.  This serves as a	*/
	/* debugging hook.						*/

	return (0);
	}

/* Receive a response from an interactive server (we sent a packet	*/
/* requesting a response, the server responded, and we just received	*/
/* that response).  Log the packet and modify the xpctd_replies list	*/
/* to account for that packet.						*/

int
rcv_pkt_interactive(rx_asn, tx_asn, buf, len, pktid)

	long		rx_asn;
	long		tx_asn;
	char		*buf;
	int		len;
	unsigned long	pktid;

	{
	static unsigned long replydatarcvd = 0;
	int		retval;
	xpctd_replies	*xp = xpctd_replies_qh;

	/* Invoke rcv_pkt to log the packet's arrival.			*/

	retval = rcv_pkt(rx_asn, tx_asn, buf, len, pktid);

	/* Each pass through the following loop removes one		*/
	/* xpctd_replies entry from the list.  Note that stream		*/
	/* protocols such as TCP can fuse packets; this can result in	*/
	/* one receive removing several xpctd_replies.			*/

	replydatarcvd += len;
	while (xp != NULL)
		{

		/* Quit if no more xpctd_replies are covered.		*/

		if (replydatarcvd <= xp->byte_seqno)
			break;

		/* Remove the current xpctd_replies entry.		*/

		xpctd_replies_qh = xp->next;
		xpctd_replies_free(xp);
		if ((xp = xpctd_replies_qh) == NULL)
			xpctd_replies_qt = &xpctd_replies_qh;
		}

	/* Tell the caller what rcv_pkt did with the buffer.		*/

	return (retval);
	}

/* Receive a packet from an interactive client that must be responded	*/
/* to.  Since packets may be glued and chopped, the commands from the	*/
/* client must be pasted back together, in general.  Therefore, a	*/
/* separate state structure is maintained for each association.		*/

int
rcv_pkt_interactive_srvr(rx_asn, tx_asn, buf, len, pktid)

	long		rx_asn;
	long		tx_asn;
	char		*buf;
	int		len;
	unsigned long	pktid;

	{
	char		*bufend;
	char		*cp = buf;
	srvr_state	*p;
	int		rplpktid;
	char		*replbuf;
	int		retval;

	/* Invoke rcv_pkt to log the packet's arrival.			*/

	retval = rcv_pkt(rx_asn, tx_asn, buf, len, pktid);

	/* If we really have a packet, get a pointer to the asn's	*/
	/* state information.  If we have an EOF or error, delete	*/
	/* the asn's state information.					*/

	if (buf != NULL)
		p = srvr_state_get(rx_asn, 0);
	else
		{
		p = srvr_state_get(rx_asn, 1);
		return (retval);
		}

	/* If this association has given us bad data in the past,	*/
	/* ignore it.							*/

	if (p->bad)
		return (retval);

	/* Each pass through the following loop consumes one byte of	*/
	/* control information or skips as much filler as possible.	*/

	bufend = &(buf[len]);
	while (cp < bufend)
		{

		/* Handle current byte as specified by current state.	*/

		switch (p->state)
		{
		case srvr_len :

			/* Accumulate the response-length field.	*/

			p->acc |= (*cp & 0x7f) << (p->nbytes * 7);
			if (++p->nbytes > 5)
				{

				/* Failed plausibility check, so ignore	*/
				/* this association from here on out.	*/

				p->bad = 1;
				log_error(NULL, NULL, rx_asn, LOGERR_INTFMT);
				}

			/* If this is the last byte, send the reply.	*/
			/* The special form of zero represented by	*/
			/* 0x80 0x00 says ``send no packet''.  This	*/
			/* can be detected by *cp==0x00, since putting	*/
			/* a zero at the end of a number does not	*/
			/* change its value.				*/

			if ((*cp & 0x80) == 0)
				{
				if (*cp == 0)
					;
				else if ((replbuf =
				          (*(prot.prot->buffer_get))(p->acc)) ==
				         NULL)
					{
					log_error(NULL, NULL, -1, LOGERR_MEM);
					(void)fprintf(stderr,
						      "%s%s: Out of memory\n",
						      "rcv_pkt_",
						      "interactive_srvr");
					abort();
					}
				else
					{
					(void)(*(prot.prot->send))(tx_asn,
								   replbuf,
								   p->acc,
								   NULL,
								   &rplpktid);
					}

				/* Set the state to pick up the skip	*/
				/* count.				*/

				p->state = srvr_skip;
				p->acc = 0;
				p->nbytes = 0;
				}

			cp++;
			break;

		case srvr_skip :

			/* Accumulate the skip field.			*/

			p->acc |= (*cp & 0x7f) << (p->nbytes * 7);

			/* If we have the full field, skip the		*/
			/* specified number of bytes.			*/

			if ((*cp & 0x80) != 0)
				{
				if (++p->nbytes > 5)
					{

					/* Failed plausibility check,	*/
					/* so ignore this association	*/
					/* from here on out.		*/

					p->bad = 1;
					log_error(NULL,
						  NULL,
						  rx_asn,
						  LOGERR_INTFMT);
					}
				cp++;
				break;
				}
			else
				{
				p->skip = p->acc - p->nbytes;
				if ((p->skip & ~0x7fffffff) != 0)
					{

					/* Failed plausibility check,	*/
					/* so ignore this association	*/
					/* from here on out.		*/

					p->bad = 1;
					log_error(NULL,
						  NULL,
						  rx_asn,
						  LOGERR_INTFMT);
					}
				p->state = srvr_skipping;
				p->nbytes = 0;

				/* drop into next leg of switch...	*/

				}

		case srvr_skipping :

			/* Skip the bytes.				*/

			cp += p->skip;

			/* If past the end of the packet, adjust the	*/
			/* count and skip the first part of the next	*/
			/* packet.  Otherwise, just skip the specified	*/
			/* length.					*/

			if ((cp > bufend) ||
			    (cp < buf))
				p->skip = cp - bufend;
			else
				{
				p->state = srvr_len;
				p->acc = 0;
				}
			break;


		}
		}

	return (retval);
	}

/* Get the state entry for the specified association, creating it if	*/
/* necessary, and returning a pointer to it.  If the delete flag is	*/
/* set, the entry is deleted if it is present and a NULL pointer	*/
/* returned.								*/

srvr_state *
srvr_state_get(asn, delete)

	long		asn;
	int		delete;

	{
	srvr_state	*p;
	srvr_state	**q;

	/* Search the list for the specified entry, if found, move it	*/
	/* to the front of the list.					*/

	for (p = srvr_state_h, q = &srvr_state_h;
	     p != NULL;
	     q = &(p->next), p = *q)
		{
		if (p->asn == asn)
			{
			*q = p->next;
			if (delete)
				{
				(void)free((char *)p);
				return (NULL);
				}
			else
				{
				p->next = srvr_state_h;
				srvr_state_h = p;
				break;
				}
			}
		}

	/* If no entry was found, create one (unless it was to be	*/
	/* deleted anyway...).						*/

	if ((p == NULL) &&
	    !delete)
		{
		if ((p = (srvr_state *)malloc(sizeof(srvr_state))) == NULL)
			{

			log_error(NULL, NULL, -1, LOGERR_MEM);
			(void)fprintf(stderr,
				      "srvr_state_get: Out of memory\n");
			abort();
			}
		p->next = srvr_state_h;
		srvr_state_h = p;
		p->state = srvr_len;
		p->asn = asn;
		p->acc = 0;
		p->nbytes = 0;
		p->bad = 0;
		}

	/* Return a pointer to the entry.				*/

	return (p);
	}

/* Append new element to action structure.				*/

void
tg_append_element(ap1, ap2)

	tg_action	*ap1;
	tg_action	*ap2;

	{

	ap1->tg_flags |= ap2->tg_flags;
	if ((ap2->tg_flags & TG_ARRIVAL) != 0)
		ap1->arrival = ap2->arrival;
	if ((ap2->tg_flags & TG_DATA) != 0)
		ap1->data_limit = ap2->data_limit;
	if ((ap2->tg_flags & TG_PACKET) != 0)
		ap1->packet_limit= ap2->packet_limit;
	if ((ap2->tg_flags & TG_LENGTH) != 0)
		ap1->length = ap2->length;
	if ((ap2->tg_flags & TG_PATIENCE) != 0)
		ap1->patience = ap2->patience;
	if ((ap2->tg_flags & TG_RESPLEN) != 0)
		ap1->resplen = ap2->resplen;
	if ((ap2->tg_flags & TG_SEED) != 0)
		ap1->seed = ap2->seed;
	if ((ap2->tg_flags & TG_TIME) != 0)
		ap1->time_limit = ap2->time_limit;
	}

/* Do not need anymore to wait.	*/

void
wait_start()

	{
/*
	if (check_deadline(&global_start_tv))
		{
		(void)fprintf(stderr, "Starting time already passed!\n");
		(void)fprintf(stderr, "Restart program!\n");
		exit(-1);
		}
	(*(prot.prot->sleep_till))(&global_start_tv);
*/	}

/* Get an expected-replies queue element.				*/

xpctd_replies *
xpctd_replies_get()

	{
	xpctd_replies	*p;

	/* If the freelist is empty, malloc up another entry.		*/

	if (xpctd_replies_flist == NULL)
		{
		p = (xpctd_replies *)malloc(sizeof(xpctd_replies));
		if (p == NULL)
			{
			(void)fprintf(stderr,
				      "xpctd_replies_get: out of memory!\n");
			abort();
			}
		p->next = NULL;
		return (p);
		}

	/* Freelist is nonempty, just grab the next element.		*/

	p = xpctd_replies_flist;
	xpctd_replies_flist = p->next;
	return (p);
	}

/* Free up an expected-replies queue element.				*/

void
xpctd_replies_free(p)

	xpctd_replies	*p;

	{

	p->next = xpctd_replies_flist;
	xpctd_replies_flist = p;
	return;
	}

/* Yacc error routine.							*/

void
yyerror(s)

	char		*s;

	{
	(void)fflush(stdout);
	(void)fprintf(stderr, "%s, line %d: %s\n", filename, lineno, s);
	/* (void)fprintf(stderr, "%s, line %d: %s\n", 
             	   current_config_file, lineno, s); */
	(void)fflush(stderr);
	got_errors = 1;
	}

void
sigint(sig, code, scp, addr)

	int		sig, code;
	struct sigcontext *scp;
	char		*addr;
{

	log_close();
}


